!=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~=~
!                                          numgeo
!                Copyright (C) 2018-2023 Jan Machacek, Patrick Staubach
!=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~=~
!
! SUBROUTINE: user_contact_properties
!
!> author: Patrick Staubach, patrick.staubach@yahoo.de
!> date: 06.05.2020
!
!> Interface to user subroutine to define amplitude value
!
!>### History
!> 06.05.2020, P. Staubach - Initial version
!> 05.07.2023, P. Staubach - Windows version
!
!=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~~=~=~
subroutine user_amplitude(time,nprops,props,value) 
  implicit none
  !DEC$ ATTRIBUTES DLLEXPORT, STDCALL, REFERENCE :: user_amplitude
  real(8)                    , intent(in)    :: time                !! current step time 
  integer                    , intent(in)    :: nprops              !! number of user specified properties
  real(8), dimension(nprops) , intent(in)    :: props               !! properties of this amplitude
  real(8), dimension(3)      , intent(inout) :: value               !! value of this amplitude               

  real(8), parameter :: pi = 3.147d0
  real(8), parameter :: omega = 2.0d0 * pi * 2.0d0
  real(8), parameter :: omega2 = 2.0d0 * pi * 10.0d0
  
  value = 0.0d0
  value(1) = time+(sin(omega*time)/5.0d0-sin(omega2*time)/20.d0)
  
end subroutine user_amplitude
